;IRProgram.bas
	
irdata 			var		word 							;Set avariables to hold temporary data
headerlength	var		word
pulselength		var		word
IR_DATA_PIN		con		P6								;Infrared input is at Pin 6

Main
	low P0
	gosub wait											;Call the wait subroutine
	if irdata <> 0 then gosub TestIRData				;If irdata is anything other than 0 
														;run TestIRData
	irdata = 0											;clear irdata
	goto Main
wait
	irdata = 0											;clear irdata
	pulsin IR_DATA_PIN,0,WaitEnd,1,headerlength 		;wait for a pulse, if one comes 
														;put the length in 'headerlength' 
	if headerlength > 2250 then readir					;check if the pulse is greater than 
														;2250uS. If so, goto 'readir'
WaitEnd
	irdata = 0											;clear irdata
	return

;Start reading the pulses==================================================
readir
	if headerlength > 2750 then WaitEnd					;check if the pulse is greater than 
														;2750uS, if so goto 'WaitEnd'
pulse1
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength			;wait for the next pulse and 
														;store the length in 'pulselength'
	if pulselength < 400 then WaitEnd					;if 'pulselength' is less than 
														;400uS then goto 'WaitEnd'
	if pulselength < 1000 then pulse2					;if 'pulselength is less than 
														;1000uS then goto 'pulse2'
	irdata = irdata + %1000000000000000					;Add a high bit 16 
pulse2
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength	
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse3			
	irdata = irdata + %100000000000000					;Add a high bit 15 
pulse3
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength	
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse4			
	irdata = irdata + %10000000000000					;Add a high bit 14 
pulse4
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength	
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse5			
	irdata = irdata + %1000000000000					;Add a high bit 13 
pulse5
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength	
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse6			
	irdata = irdata + %100000000000						;Add a high bit 12 
pulse6
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength	
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse7			
	irdata = irdata + %10000000000						;Add a high bit 11 
pulse7
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength	
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse8			
	irdata = irdata + %1000000000						;Add a high bit 10 
pulse8
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength	
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse9			
	irdata = irdata + %100000000						;Add a high bit 9 
pulse9
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength	
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse10		
	irdata = irdata + %10000000							;Add a high bit 8 
pulse10
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength	
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse11			
	irdata = irdata + %1000000							;Add a high bit 7 
pulse11	
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse12			
	irdata = irdata + %100000							;Add a high bit 6 
pulse12
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		
	if pulselength < 400 then WaitEnd				
	if pulselength < 1000 then endreadir			
	irdata = irdata + %10000							;Add a high bit 5 
endreadir
	return

TestIRData
	if irdata = %0000100100000000 then motorforward		;if up arrow then motor clockwise 
	if irdata = %1000100100000000 then motorbackward 	;if down arrow then anticlockwise
	if irdata = %0100100100000000 then lightLED			;if right arrow then light LED
	if irdata = %1100100100000000 then playbuzzer		;if left arrow then play tune
	return

motorforward
	Serout P4,i2400,["C",255]  	
	pulsin IR_DATA_PIN,0,MotorForwardEnd,1,headerlength	;whilst IR data is still 
	goto motorforward									;coming, keep in this loop
MotorForwardEnd	
	pulsout P4,6000										;Stop Motor
	return

motorbackward
	Serout P4,i2400,["A",255]  		
	pulsin IR_DATA_PIN,0,MotorBackwardEnd,1,headerlength;whilst IR data is still 
	goto motorbackward									;coming,keep in this loop
MotorBackwardEnd	
	pulsout P4,6000										;Stop Motor
	return

lightLED
	High P0
	Pause 2000	
	return

playbuzzer
	sound P2,[400\450,50\0,400\450,400\675,50\0,400\675,50\0,400\750,50\0,400\750,800\675] 
	return
	end